Index: /trunk/src/lib/graphics/effects/rain_effect.cc
===================================================================
--- /trunk/src/lib/graphics/effects/rain_effect.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/rain_effect.cc	(revision 8495)
@@ -31,6 +31,6 @@
 SHELL_COMMAND(activate, RainEffect, activateRain);
 SHELL_COMMAND(deactivate, RainEffect, deactivateRain);
-
-SHELL_COMMAND(startRaining, RainEffect, startRaining);
+SHELL_COMMAND(startraining, RainEffect, startRaining);
+SHELL_COMMAND(stopraining, RainEffect, stopRaining);
 
 using namespace std;
@@ -38,85 +38,89 @@
 CREATE_FACTORY(RainEffect, CL_RAIN_EFFECT);
 
-// TODO: Dim Light with Rain, Finish preCaching, check out if multiple rain emitters work,  Think about what happens with building poss. to hang movewithcam off, benchmark, possible to activate lightening, turn off visibility when in a building, variable emitter size depending on playable, also rain velocity
-
-RainEffect::RainEffect(const TiXmlElement* root)
-{
-	this->setClassID(CL_RAIN_EFFECT, "RainEffect");
-
-	this->init();
-
-	if (root != NULL)
-		this->loadParams(root);
-
-	//load rain sound
-	if (this->rainBuffer != NULL)
-		ResourceManager::getInstance()->unload(this->rainBuffer);
-	this->rainBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/rain.wav", WAV);
-
-	//load wind sound
-	if (this->rainWindForce != 0) {
-		if (this->windBuffer != NULL)
-			ResourceManager::getInstance()->unload(this->windBuffer);
-		this->windBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/wind.wav", WAV);
-	}
-
-	if(rainActivate)
-		this->activate();
-}
-
-RainEffect::~RainEffect()
-{
-	this->deactivate();
-
-	if (this->rainBuffer != NULL)
-		ResourceManager::getInstance()->unload(this->rainBuffer);
-
-	if (this->windBuffer != NULL)
-		ResourceManager::getInstance()->unload(this->windBuffer);
-}
-
-void RainEffect::loadParams(const TiXmlElement* root)
-{
-	WeatherEffect::loadParams(root);
-
-	LoadParam(root, "coord", this, RainEffect, setRainCoord);
-	LoadParam(root, "size", this, RainEffect, setRainSize);
-	LoadParam(root, "rate", this, RainEffect, setRainRate);
-	LoadParam(root, "velocity", this, RainEffect, setRainVelocity);
-	LoadParam(root, "life", this, RainEffect, setRainLife);
-	LoadParam(root, "wind", this, RainEffect, setRainWind);
-	LoadParam(root, "startraining", this, RainEffect, setRainStart);
-
-	LOAD_PARAM_START_CYCLE(root, element);
-	{
-		LoadParam_CYCLE(element, "option", this, RainEffect, setRainOption);
-	}
-	LOAD_PARAM_END_CYCLE(element);
-
-}
-
-
-bool RainEffect::init()
-{
-	//Default values
-	this->rainActivate = false;
-	this->rainMove = false;
-	this->rainCoord = Vector(500, 500, 500);
-	this->rainSize = Vector2D(1000, 1000);
-	this->rainRate = 3000;
-	this->rainVelocity = -300;
-	this->rainLife = 4;
-	this->rainMaxParticles = this->rainRate * this->rainLife;
-	this->rainWindForce  = 0;
-	this->rainStartDuration = 0;
-	this->localTimer = 0;
-	this->soundRainVolume = 0.8f;
-
-	this->emitter = new PlaneEmitter(this->rainSize);
-
-	lightMan = LightManager::getInstance();
-	this->rainAmbient = lightMan->getAmbientColor();
-
-        return true;
+/* TODO:
+  - test multiple rain emitters
+  - Think about what happens with building poss. to hang movewithcam off
+  - Possible to activate lightening
+  - turn off visibility when in a building
+  - variable emitter size depending on playable
+*/
+
+RainEffect::RainEffect(const TiXmlElement* root) {
+    this->setClassID(CL_RAIN_EFFECT, "RainEffect");
+
+    this->init();
+
+    if (root != NULL)
+        this->loadParams(root);
+
+    //load rain sound
+    if (this->rainBuffer != NULL)
+        ResourceManager::getInstance()->unload(this->rainBuffer);
+    this->rainBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/atmosphere/rain.wav", WAV);
+
+    //load wind sound
+    if (this->rainWindForce != 0) {
+        if (this->windBuffer != NULL)
+            ResourceManager::getInstance()->unload(this->windBuffer);
+        this->windBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/atmosphere/wind.wav", WAV);
+    }
+
+    if(rainActivate) {
+        this->activate();
+        RainEffect::rainParticles->precache((int)this->rainLife * 5); // TODO: Figure out the correct value
+    }
+}
+
+RainEffect::~RainEffect() {
+    this->deactivate();
+
+    if (this->rainBuffer != NULL)
+        ResourceManager::getInstance()->unload(this->rainBuffer);
+
+    if (this->windBuffer != NULL)
+        ResourceManager::getInstance()->unload(this->windBuffer);
+}
+
+void RainEffect::loadParams(const TiXmlElement* root) {
+    WeatherEffect::loadParams(root);
+
+    LoadParam(root, "coord", this, RainEffect, setRainCoord);
+    LoadParam(root, "size", this, RainEffect, setRainSize);
+    LoadParam(root, "rate", this, RainEffect, setRainRate);
+    LoadParam(root, "velocity", this, RainEffect, setRainVelocity);
+    LoadParam(root, "life", this, RainEffect, setRainLife);
+    LoadParam(root, "wind", this, RainEffect, setRainWind);
+    LoadParam(root, "fadeinduration", this, RainEffect, setRainFadeIn);
+    LoadParam(root, "fadeoutduration", this, RainEffect, setRainFadeOut);
+
+    LOAD_PARAM_START_CYCLE(root, element);
+    {
+        LoadParam_CYCLE(element, "option", this, RainEffect, setRainOption);
+    }
+    LOAD_PARAM_END_CYCLE(element);
+
+}
+
+
+void RainEffect::init() {
+    //Default values
+    this->rainActivate = false;
+    this->rainMove = false;
+    this->rainCoord = Vector(500, 500, 500);
+    this->rainSize = Vector2D(1000, 1000);
+    this->rainRate = 4000;
+    this->rainVelocity = -300;
+    this->rainLife = 4;
+    this->rainMaxParticles = this->rainRate * this->rainLife;
+    this->rainWindForce  = 0;
+    this->rainFadeInDuration = 0;
+    this->rainFadeOutDuration = 0;
+    this->localTimer = 0;
+    this->soundRainVolume = 0.8f;
+
+    this->emitter = new PlaneEmitter(this->rainSize);
+
+    lightMan = LightManager::getInstance();
+    this->rainAmbient = lightMan->getAmbientColor();
 }
 
@@ -124,88 +128,106 @@
 SparkParticles* RainEffect::rainParticles = NULL;
 
-bool RainEffect::activate()
-{
-	PRINTF(0)( "Activating RainEffect, coord: %f, %f, %f, size: %f, %f, rate: %f, velocity: %f, moveRain: %s\n", this->rainCoord.x, this->rainCoord.y, this->rainCoord.z, this->rainSize.x, this-> rainSize.y, this->rainRate, this->rainVelocity, this->rainMove ? "true" : "false" );
-
-	this->rainActivate = true;
-
-	if (unlikely(RainEffect::rainParticles == NULL))
-	{
-		RainEffect::rainParticles = new SparkParticles((int) this->rainMaxParticles);
-		RainEffect::rainParticles->setName("RainParticles");
-		RainEffect::rainParticles->precache((int)this->rainLife);
-		RainEffect::rainParticles->setLifeSpan(this->rainLife, 2);
-		RainEffect::rainParticles->setRadius(0, 0.03);
-		RainEffect::rainParticles->setRadius(0.2, 0.02);
-		RainEffect::rainParticles->setRadius(1, 0.01);
-		RainEffect::rainParticles->setColor(0, 0.3, 0.3, 0.5, 0.2);	// grey blue 1
-		RainEffect::rainParticles->setColor(0.5, 0.4, 0.4, 0.5, 0.2);	// grey blue 2
-		RainEffect::rainParticles->setColor(1, 0.7, 0.7, 0.7, 0.2);	// light grey
-	}
-
-	this->emitter->setSystem(RainEffect::rainParticles);
-
-	this->emitter->setRelCoor(this->rainCoord);
-
-	this->emitter->setEmissionRate(this->rainRate);
-	this->emitter->setEmissionVelocity(this->rainVelocity);
-
-	this->emitter->setSpread(this->rainWindForce / 50, 0.2);
-
-	this->soundSource.loop(this->rainBuffer, this->soundRainVolume);
-	if (this->rainWindForce != 0) this->soundSource.loop(this->windBuffer, 0.1f * this->rainWindForce);
-
-	lightMan->setAmbientColor(.1,.1,.1);
-
-        return true;
-}
-
-
-bool RainEffect::deactivate()
-{
-	PRINTF(0)("Deactivating RainEffect\n");
-
-	this->rainActivate = false;
-	this->emitter->setSystem(NULL);
-
-	// Stop Sound
-	this->soundSource.stop();
-
-	// Restore Light Ambient
-	lightMan->setAmbientColor(this->rainAmbient, this->rainAmbient, this->rainAmbient);
-
-        return true;
-}
-
-void RainEffect::tick (float dt)
-{
-	if (!this->rainActivate)
-		return;
-
-	if (this->rainMove) {
-		this->rainCoord = State::getCameraNode()->getAbsCoor();
-		this->emitter->setRelCoor(this->rainCoord.x , this->rainCoord.y+800, this->rainCoord.z);
-	}
-
-	if (this->rainStartDuration != 0 && this->localTimer < this->rainStartDuration) {
-		this->localTimer += dt;
-		float progress = this->localTimer / this->rainStartDuration;
-
-		// Dim Light
-		lightMan->setAmbientColor(1.1 - progress, 1.1 - progress, 1.1 - progress);
-
-		// use alpha in color to fade in
-		RainEffect::rainParticles->setColor(0,   0.3, 0.3, 0.5, 0.2 * progress); // grey blue 1
-		RainEffect::rainParticles->setColor(0.5, 0.4, 0.4, 0.5, 0.2 * progress); // grey blue 2
-		RainEffect::rainParticles->setColor(1,   0.7, 0.7, 0.7, 0.2 * progress); // light grey
-
-		// increase radius for more "heavy" rain
-		RainEffect::rainParticles->setRadius(0, 0.03 * progress);
-		RainEffect::rainParticles->setRadius(0.2, 0.02 * progress);
-		RainEffect::rainParticles->setRadius(1, 0.01 * progress);
-
-		// increase sound volume
-		// this->soundSource.fadein(this->rainBuffer, 10);
-	}
+void RainEffect::activate() {
+    PRINTF(0)( "Activating RainEffect, coord: %f, %f, %f, size: %f, %f, rate: %f, velocity: %f, moveRain: %s\n", this->rainCoord.x, this->rainCoord.y, this->rainCoord.z, this->rainSize.x, this-> rainSize.y, this->rainRate, this->rainVelocity, this->rainMove ? "true" : "false" );
+
+    this->rainActivate = true;
+
+    if (unlikely(RainEffect::rainParticles == NULL)) {
+        RainEffect::rainParticles = new SparkParticles((int) this->rainMaxParticles);
+        RainEffect::rainParticles->setName("RainParticles");
+        RainEffect::rainParticles->setLifeSpan(this->rainLife, 2);
+        RainEffect::rainParticles->setRadius(0, 0.03);
+        RainEffect::rainParticles->setRadius(0.2, 0.02);
+        RainEffect::rainParticles->setRadius(1, 0.01);
+        RainEffect::rainParticles->setColor(0, 0.3, 0.3, 0.5, 0.2); // grey blue 1
+        RainEffect::rainParticles->setColor(0.5, 0.4, 0.4, 0.5, 0.2); // grey blue 2
+        RainEffect::rainParticles->setColor(1, 0.7, 0.7, 0.7, 0.2); // light grey
+    }
+
+    this->emitter->setSystem(RainEffect::rainParticles);
+
+    this->emitter->setRelCoor(this->rainCoord);
+
+    this->emitter->setEmissionRate(this->rainRate);
+    this->emitter->setEmissionVelocity(this->rainVelocity);
+
+    this->emitter->setSpread(this->rainWindForce / 50, 0.2);
+
+    this->soundSource.play(this->rainBuffer, this->soundRainVolume, true);
+
+    if (this->rainWindForce != 0)
+        this->soundSource.play(this->windBuffer, 0.1f * this->rainWindForce, true);
+
+    if (this->rainFadeInDuration == 0)
+        lightMan->setAmbientColor(.1,.1,.1);
+
+}
+
+
+void RainEffect::deactivate() {
+    PRINTF(0)("Deactivating RainEffect\n");
+
+    this->rainActivate = false;
+    this->emitter->setSystem(NULL);
+
+    // Stop Sound
+    this->soundSource.stop();
+
+    // Restore Light Ambient
+    lightMan->setAmbientColor(this->rainAmbient, this->rainAmbient, this->rainAmbient);
+
+}
+
+void RainEffect::tick (float dt) {
+    if (!this->rainActivate)
+        return;
+
+    if (this->rainMove) {
+        this->rainCoord = State::getCameraNode()->getAbsCoor();
+        this->emitter->setRelCoor(this->rainCoord.x , this->rainCoord.y+800, this->rainCoord.z);
+    }
+
+    if (this->rainFadeInDuration != 0 && this->localTimer < this->rainFadeInDuration) {
+        this->localTimer += dt;
+        float progress = this->localTimer / this->rainFadeInDuration;
+
+        // Dim Light
+        lightMan->setAmbientColor(1 - progress * 0.9, 1 - progress * 0.9, 1 - progress * 0.9);
+
+        // use alpha in color to fade in
+        RainEffect::rainParticles->setColor(0,   0.3, 0.3, 0.5, 0.2 * progress); // grey blue 1
+        RainEffect::rainParticles->setColor(0.5, 0.4, 0.4, 0.5, 0.2 * progress); // grey blue 2
+        RainEffect::rainParticles->setColor(1,   0.7, 0.7, 0.7, 0.2 * progress); // light grey
+
+        // increase radius for more "heavy" rain
+        RainEffect::rainParticles->setRadius(0, 0.03 * progress);
+        RainEffect::rainParticles->setRadius(0.2, 0.02 * progress);
+        RainEffect::rainParticles->setRadius(1, 0.01 * progress);
+
+        // increase sound volume
+        // this->soundSource.fadein(this->rainBuffer, 10);
+    } else if ( this->rainFadeOutDuration != 0 ) {
+        if ( this->localTimer < this->rainFadeOutDuration ) {
+            this->localTimer += dt;
+            float progress = 1 - (this->localTimer / this->rainFadeOutDuration);
+
+            // Fade In Light
+            lightMan->setAmbientColor(1 - progress * 0.9, 1 - progress * 0.9, 1 - progress * 0.9);
+
+            // use alpha in color to fade out
+            RainEffect::rainParticles->setColor(0,   0.3, 0.3, 0.5, 0.2 * progress); // grey blue 1
+            RainEffect::rainParticles->setColor(0.5, 0.4, 0.4, 0.5, 0.2 * progress); // grey blue 2
+            RainEffect::rainParticles->setColor(1,   0.7, 0.7, 0.7, 0.2 * progress); // light grey
+
+            // decrease radius
+            RainEffect::rainParticles->setRadius(0, 0.03 * progress);
+            RainEffect::rainParticles->setRadius(0.2, 0.02 * progress);
+            RainEffect::rainParticles->setRadius(1, 0.01 * progress);
+
+            // decrease sound volume
+            // this->soundSource.fadeout(this->rainBuffer, 10);
+        } else
+            this->deactivate();
+    }
 
 }
@@ -213,10 +235,25 @@
 void RainEffect::startRaining() {
 
-	if (this->rainActivate)
-		this->deactivate();
-
-	this->rainStartDuration = 10;
-	this->localTimer = 0;
-	this->activate();
-
-}
+    if (this->rainActivate)
+        this->deactivate();
+
+    if (!this->rainFadeInDuration > 0)
+        this->rainFadeInDuration = 20;
+
+    this->localTimer = 0;
+
+    this->activate();
+
+}
+
+void RainEffect::stopRaining() {
+
+    if (!this->rainActivate)
+        this->activate();
+
+    if (!this->rainFadeOutDuration > 0)
+        this->rainFadeOutDuration = 20;
+
+    this->localTimer = 0;
+
+}
Index: /trunk/src/lib/graphics/effects/rain_effect.h
===================================================================
--- /trunk/src/lib/graphics/effects/rain_effect.h	(revision 8494)
+++ /trunk/src/lib/graphics/effects/rain_effect.h	(revision 8495)
@@ -22,62 +22,88 @@
 
 
-class RainEffect : public WeatherEffect
-{
-	public:
-		RainEffect(const TiXmlElement* root = NULL);
-		virtual ~RainEffect();
+class RainEffect : public WeatherEffect {
+public:
+    RainEffect(const TiXmlElement* root = NULL);
+    virtual ~RainEffect();
 
-		virtual void loadParams(const TiXmlElement* root);
+    virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+    virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+    virtual void activate();
+    virtual void deactivate();
 
-		virtual void tick(float dt);
+    inline void activateRain() {
+        this->activate();
+    }
+    inline void deactivateRain() {
+        this->deactivate();
+    }
 
-		inline void activateRain() { this->activate(); }
-		inline void deactivateRain() { this->deactivate(); }
-		void startRaining();
+    virtual void tick(float dt);
 
-		inline void setRainCoord(float x, float y, float z) { this->rainCoord = Vector(x, y, z); }
-		inline void setRainSize(float x, float y) { this->rainSize = Vector2D(x, y); }
-		inline void setRainRate(float rate) { this->rainRate = rate;}
-		inline void setRainVelocity(float velocity) { this->rainVelocity = -velocity; }
-		inline void setRainLife(float life) { this->rainLife = life; }
-		inline void setRainWind(int force) { this->rainWindForce = force; }
-		inline void setRainStart(float duration) { this->rainStartDuration = duration; }
+    void startRaining();
+    void stopRaining();
 
-		inline void setRainOption(const std::string& option) {
-			if (option == "moverain") this->rainMove = true;
-			if (option == "activate") this->rainActivate = true;
-		}
+    inline void setRainCoord(float x, float y, float z) {
+        this->rainCoord = Vector(x, y, z);
+    }
+    inline void setRainSize(float x, float y) {
+        this->rainSize = Vector2D(x, y);
+    }
+    inline void setRainRate(float rate) {
+        this->rainRate = rate;
+    }
+    inline void setRainVelocity(float velocity) {
+        this->rainVelocity = -velocity;
+    }
+    inline void setRainLife(float life) {
+        this->rainLife = life;
+    }
+    inline void setRainWind(int force) {
+        this->rainWindForce = force;
+    }
+
+    inline void setRainFadeIn(float fadein) {
+        this->rainFadeInDuration = fadein;
+    }
+    inline void setRainFadeOut(float fadeout) {
+        this->rainFadeOutDuration = fadeout;
+    }
+
+    inline void setRainOption(const std::string& option) {
+        if (option == "moverain")
+            this->rainMove = true;
+        if (option == "activate")
+            this->rainActivate = true;
+    }
 
 
-	private:
-		static SparkParticles*			rainParticles;
-		ParticleEmitter*			emitter;
+private:
+    static SparkParticles*      rainParticles;
+    ParticleEmitter*            emitter;
 
-		float					localTimer;
+    GLfloat         rainFadeInDuration;
+    GLfloat         rainFadeOutDuration;
+    float           localTimer;
 
-		Vector					rainCoord;
-		Vector2D				rainSize;
-		GLfloat					rainRate;
-		GLfloat					rainVelocity;
-		GLfloat					rainLife;
-		GLfloat					rainMaxParticles;
-		int					rainWindForce;
-		GLfloat					rainStartDuration;
-		bool					rainMove;
-		bool					rainActivate;
+    Vector          rainCoord;
+    Vector2D        rainSize;
+    GLfloat         rainRate;
+    GLfloat         rainVelocity;
+    GLfloat         rainLife;
+    GLfloat         rainMaxParticles;
+    int             rainWindForce;
+    bool            rainMove;
+    bool            rainActivate;
 
-		OrxSound::SoundSource			soundSource;
-		OrxSound::SoundBuffer*			rainBuffer;
-		OrxSound::SoundBuffer*			windBuffer;
+    OrxSound::SoundSource     soundSource;
+    OrxSound::SoundBuffer*      rainBuffer;
+    OrxSound::SoundBuffer*      windBuffer;
 
-		float					soundRainVolume;
+    float         soundRainVolume;
 
-		LightManager*				lightMan;
-		GLfloat					rainAmbient;
+    LightManager*       lightMan;
+    GLfloat         rainAmbient;
 
 };
Index: /trunk/src/lib/graphics/effects/snow_effect.cc
===================================================================
--- /trunk/src/lib/graphics/effects/snow_effect.cc	(revision 8494)
+++ /trunk/src/lib/graphics/effects/snow_effect.cc	(revision 8495)
@@ -50,9 +50,11 @@
 		if (this->windBuffer != NULL)
 			ResourceManager::getInstance()->unload(this->windBuffer);
-	       		this->windBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/wind.wav", WAV);
-	}
-
-	if(snowActivate)
+	       		this->windBuffer = (OrxSound::SoundBuffer*)ResourceManager::getInstance()->load("sound/atmosphere/wind.wav", WAV);
+	}
+
+  if(snowActivate) {
 		this->activate();
+    SnowEffect::snowParticles->precache((int) this->snowLife);
+  }  
 }
 
@@ -87,5 +89,5 @@
 }
 
-bool SnowEffect::init()
+void SnowEffect::init()
 {
 	this->emitter = new PlaneEmitter();
@@ -96,5 +98,5 @@
 	this->particles = 12000;
 	this->texture = "maps/snow_flake_01_32x32.png";
-	this->life = 8;
+	this->snowLife = 8;
 	this->randomLife = 2;
 	this->snowRadius = 3.5;
@@ -111,9 +113,7 @@
 	this->snowCoord = Vector(100,450,400);
 	this->snowWindForce = 1;
-
-        return true;
-}
-
-bool SnowEffect::activate()
+}
+
+void SnowEffect::activate()
 {
 	PRINTF(0)("Activating SnowEffect\n");
@@ -124,5 +124,5 @@
 	SnowEffect::snowParticles->setName("SnowEffectTrailParticles");
 	SnowEffect::snowParticles->setMaterialTexture(texture);
-	SnowEffect::snowParticles->setLifeSpan(life, randomLife);
+	SnowEffect::snowParticles->setLifeSpan(snowLife, randomLife);
 	SnowEffect::snowParticles->setRadius(0.0, snowRadius, randomRadius);
 	SnowEffect::snowParticles->setRadius(0.2, snowRadius, randomRadius*0.8);
@@ -141,14 +141,11 @@
 	this->emitter->setSize(snowSize);
 
-	// SnowEffect::snowParticles->precache(8);
-
-	if (this->snowWindForce > 1)
-		this->soundSource.loop(this->windBuffer);
-
-        return true;
-}
-
-
-bool SnowEffect::deactivate()
+  if (this->snowWindForce != 0)
+    this->soundSource.play(this->windBuffer, 0.1f * this->snowWindForce, true);
+ 
+}
+
+
+void SnowEffect::deactivate()
 {
 	PRINTF(0)("Deactivating SnowEffect\n");
@@ -159,6 +156,4 @@
 	if (this->windBuffer != NULL)
 		ResourceManager::getInstance()->unload(this->windBuffer);
-
-        return true;
 }
 
Index: /trunk/src/lib/graphics/effects/snow_effect.h
===================================================================
--- /trunk/src/lib/graphics/effects/snow_effect.h	(revision 8494)
+++ /trunk/src/lib/graphics/effects/snow_effect.h	(revision 8495)
@@ -20,64 +20,93 @@
 #include "sound_buffer.h"
 
-class SnowEffect : public WeatherEffect
-{
-	public:
-		SnowEffect(const TiXmlElement* root = NULL);
-		virtual ~SnowEffect();
+class SnowEffect : public WeatherEffect {
+public:
+    SnowEffect(const TiXmlElement* root = NULL);
+    virtual ~SnowEffect();
 
-		virtual void loadParams(const TiXmlElement* root);
+    virtual void loadParams(const TiXmlElement* root);
 
-		virtual bool init();
+    virtual void init();
 
-		virtual bool activate();
-		virtual bool deactivate();
+    virtual void activate();
+    virtual void deactivate();
 
-		inline void activateSnow() { this->activate(); }
-		inline void deactivateSnow() { this->deactivate(); }
-		
-		virtual void draw() const;
-		virtual void tick(float dt);
+    inline void activateSnow() {
+        this->activate();
+    }
+    inline void deactivateSnow() {
+        this->deactivate();
+    }
+
+    virtual void draw() const;
+    virtual void tick(float dt);
 
 
-		inline void numParticles(int n) { this->particles = n; }
-		inline void materialTexture(const std::string& texture) { this->texture = texture; }
-		inline void lifeSpan(float lifeSpan, float randomLifeSpan) { this->life = lifeSpan; this->randomLife = randomLifeSpan; }
-		inline void radius(float radius, float randomRadius) { this->snowRadius = radius; this->randomRadius = randomRadius; }
-		inline void mass(float mass, float randomMass) { this->snowMass = mass; this->randomMass = randomMass; }
-		inline void emissionRate(float emissionRate){ this->rate = emissionRate; }
-		inline void emissionVelocity(float velocity, float randomVelocity){ this->velocity = velocity; this->randomVelocity = randomVelocity; }
-		inline void size(float sizeX, float sizeY) { this->snowSize = Vector2D(sizeX, sizeY); }
-		inline void coord(float x, float y, float z) { this->snowCoord = Vector(x, y, z); }
-		inline void wind(int force) { this->snowWindForce = force; }
+    inline void numParticles(int n) {
+        this->particles = n;
+    }
+    inline void materialTexture(const std::string& texture) {
+        this->texture = texture;
+    }
+    inline void lifeSpan(float lifeSpan, float randomLifeSpan) {
+        this->snowLife = lifeSpan;
+        this->randomLife = randomLifeSpan;
+    }
+    inline void radius(float radius, float randomRadius) {
+        this->snowRadius = radius;
+        this->randomRadius = randomRadius;
+    }
+    inline void mass(float mass, float randomMass) {
+        this->snowMass = mass;
+        this->randomMass = randomMass;
+    }
+    inline void emissionRate(float emissionRate) {
+        this->rate = emissionRate;
+    }
+    inline void emissionVelocity(float velocity, float randomVelocity) {
+        this->velocity = velocity;
+        this->randomVelocity = randomVelocity;
+    }
+    inline void size(float sizeX, float sizeY) {
+        this->snowSize = Vector2D(sizeX, sizeY);
+    }
+    inline void coord(float x, float y, float z) {
+        this->snowCoord = Vector(x, y, z);
+    }
+    inline void wind(int force) {
+        this->snowWindForce = force;
+    }
 
-		inline void setSnowOption(const std::string& option) {
-			/*if (option == "fade") this->snowFade = true;*/
-			if (option == "movesnow") this->snowMove = true;
-			if (option == "activate") this->snowActivate = true;
-		}
+    inline void setSnowOption(const std::string& option) {
+        /*if (option == "fade") this->snowFade = true;*/
+        if (option == "movesnow")
+            this->snowMove = true;
+        if (option == "activate")
+            this->snowActivate = true;
+    }
 
 
-	private:
-		int 				particles;
-		std::string 			texture;
-		float				life, randomLife;
-		float				snowRadius, randomRadius;
-		float				snowMass, randomMass;
-		float 				rate;
-		float 				velocity, randomVelocity;
-		float 				angle, randomAngle;
-		float 				alpha;
-		Vector 				snowCoord;
-		Vector2D 			snowSize;
-		int				snowWindForce;
+private:
+    int         particles;
+    std::string       texture;
+    float       snowLife, randomLife;
+    float       snowRadius, randomRadius;
+    float       snowMass, randomMass;
+    float         rate;
+    float         velocity, randomVelocity;
+    float         angle, randomAngle;
+    float         alpha;
+    Vector        snowCoord;
+    Vector2D      snowSize;
+    int       snowWindForce;
 
-		bool 				snowMove;
-		bool 				snowActivate;
+    bool        snowMove;
+    bool        snowActivate;
 
-		PlaneEmitter*			emitter;
+    PlaneEmitter*     emitter;
 
-		static SpriteParticles*		snowParticles;
-		OrxSound::SoundSource		soundSource;
-		OrxSound::SoundBuffer*		windBuffer;
+    static SpriteParticles*   snowParticles;
+    OrxSound::SoundSource   soundSource;
+    OrxSound::SoundBuffer*    windBuffer;
 
 };
